#ifndef	LOLDRAW_H
#define	LOLDRAW_H

#include "Charliplexing.h"

/*
Istructions for the LOLDraw Library for the LOL Shield and Olimexino-328

The LOLDraw Library provides easy-to-use functions for drawing
geometrical figures.

To use it, copy the LOLDraw folder(with the .h and .cpp file inside)
to the libraries folder of the arduino environment.

Include it in your sketches like that:

#include "LOLDraw.h"

and call the functions like that:

LOLDraw::<Function name>(<param1>, <param2>...);

*/


namespace LOLDraw
{
	/* x and y are the coordinates of a sigle diode to be lit 
	   where x is the column and y the row */
	void Point( uint8_t x, uint8_t y);
	
	/* Draws a line between diodes (x1;y1) and (x2,y2) */
	void Line( int x1, int y1, int x2, int y2);
	
	/* Draws a triangle between (x1;y1), (x2,y2) and (x3,y3) */
	void Triangle (uint8_t x1, uint8_t y1, uint8_t x2, uint8_t y2, uint8_t x3, uint8_t y3);
	
	/* Draws a rectangle using (x1;y1) as the top left corner and 
	   (x2;y2) as the bottom right corner */
	void Rectangle( uint8_t x1, uint8_t y1, uint8_t x2, uint8_t y2);
	
	/* Draws an Ellipse using (CX,CY) as a center and XRadius and YRadius
       as the two radiuses */	
	void Ellipse(uint8_t CX, uint8_t CY, uint8_t XRadius, uint8_t YRadius);
	
	/* A helper function for the Ellipse function; not to be called directly */
	void Draw_4_Ellipse_Points(uint8_t CX, uint8_t CY, uint8_t X, uint8_t Y);
	
	/* Draws a Circle using (x;y) as a center and r as the radius */
	void Circle(uint8_t x, uint8_t y, uint8_t r);
	
}



#endif